Subject: TCP Performance Implications of Network Asymmetry

From: Herbert Hanewinkel <[email-masked]>
Date: Tue, 20 Feb 2001 13:57:15 +0100

Hi,

I read the draft to get some ideas for improving my ADSL PPPoE
dialer (driver) for Windows.

With the PPPoE protocol (RFC 2516) a widely used ADSL
environment for end users consists of a Ethernet connection
from an end system (PC) to an external ADSL modem.
The ADSL modem connects to the asymmetric link.

The ADSL access offered here in Germany by Deutsche Telekom
has a speed ratio of 6 (768/128 kbits). On bi-directional
traffic with a heavily loaded uplink the downlink speed 
decreases to nearly symmetrical link speed.

I am faced with the following situation:

- the memory size (queue size) of the ADSL modem may vary from
  one model to another.
 
- the uplink queue in the ADSL modem is out of control of the
  dialer software.

- the ADSL modem operates transparent. Has no knowledge of
  the protocols in use, forewards only ppp packets. There
  doesn't do ACK first-scheduling.

- My driver forwards IP packets in both directions
  without control over the IP stack itself.

My practcial experiments show:

- Using TCP header compression on the uplink doesn't make a
  big difference.

- Backpressing seems to be the most effective way to
  improve the situtation on bi-directional traffic.
  I implemented it by reducing the announced window size
  in received packets.
  The downlink speed goes up on cost of up link speed,
  but my actual simple scheme of reducing the window size
  if a certain uplink load is exceeded, procduces a heavily
  varying behaviour. How to calculate the reduced
  TCP windowsize based on the speed ratio and the load?

Best regards,

Herbert Hanewinkel

--------------------------------------------------------
Dr. Herbert Hanewinkel
email:[email-masked]         http://www.heha.cjb.net